/*!
 * @danielhaim/autotoc - v1.5.0 - 2024-08-29
 * git+https://github.com/danielhaim1/autotoc.git
 * Copyright (c) 2024 Daniel Haim, Licensed MIT
 */(()=>{"use strict";var t={987:(t,e,i)=>{var n;const o={Generate:i(954).Generate};t.exports&&(t.exports=o),void 0===(n=function(){return o}.apply(e,[]))||(t.exports=n),"object"==typeof window&&(window.AutoToc=o)},954:(t,e,i)=>{Object.defineProperty(e,"__esModule",{value:!0}),e.Generate=void 0;(n=i(868))&&n.__esModule;var n,o=i(253);e.Generate=class{constructor(t,e,i,n,o,r,s=3,l=1/0,a=""){this.slugCount=new Map,this.contentSelector=t,this.navigationContainer=e,this.tocTitle=i,this.tocIcon=n,this.highlightOffset=o,this.headingDepthLimit=r,this.minElements=s,this.maxElements=l,this.ignoreSelector=a,this.tocMap=new Map,this.tocTopMap=new Map,this.tocBottomMap=new Map,this.pendingExternalLinks=[]}validateParameters(){const t=t=>{try{return null!==document.querySelector(t)}catch(t){return!1}};if("string"!=typeof this.contentSelector||!t(this.contentSelector))throw new Error("Invalid contentSelector: Must be a valid CSS selector string for an existing element.");if("string"!=typeof this.navigationContainer||!t(this.navigationContainer))throw new Error("Invalid navigationContainer: Must be a valid CSS selector string for an existing element.");if("string"!=typeof this.tocTitle)throw new Error("Invalid tocTitle: Must be a string.");if(null!==this.tocIcon&&"string"!=typeof this.tocIcon)throw new Error("Invalid tocIcon: Must be a string or null.");if("number"!=typeof this.highlightOffset||this.highlightOffset<0)throw new Error("Invalid highlightOffset: Must be a non-negative number.");if("number"!=typeof this.headingDepthLimit||this.headingDepthLimit<1||this.headingDepthLimit>6||!Number.isInteger(this.headingDepthLimit))throw new Error("Invalid headingDepthLimit: Must be an integer between 1 and 6.")}detachEventListeners(){window.removeEventListener("scroll",this.boundScrollListener)}generateUniqueId(t){const e=(new o.slugify).generate(t.textContent||""),i=this.slugCount.get(e)||0;return this.slugCount.set(e,i+1),`${e}-${i+1}`}populateTocMap(){let t=document.querySelectorAll(this.createHeadingSelector());this.ignoreSelector&&(t=Array.from(t).filter((t=>!t.closest(this.ignoreSelector))));const e=new Map;t.forEach((t=>{if(!this.ignoreSelector||!t.closest(this.ignoreSelector)){const i=parseInt(t.tagName.substring(1),10),n=t.id||this.generateUniqueId(t),o=t.textContent.trim();this.tocMap.has(n)||e.set(n,{level:i,text:o})}})),this.tocMap=new Map([...this.tocMap,...e]),this.renderTocHtml()}createTocList(t){const e=document.createElement("ol");return 0===t.size||t.forEach(((t,i)=>{const{level:n,text:o}=t,r=o.replace(/^#/,""),s=document.createElement("li");s.className=`toc-list--item level-${n}`,s.setAttribute("role","listitem");const l=document.createElement("a");l.href=`#${i}`,l.textContent=r,s.appendChild(l),e.appendChild(s)})),e}findFirstHeadingLevel(){for(let t=1;t<=this.headingDepthLimit;t++)if(document.querySelector(`${this.contentSelector} > h${t}`))return console.log(t),t;return null}renderTocHtml(){if(this.tocMap.size<this.minElements)return void console.log("Not enough headings to generate TOC");let t=this.findFirstHeadingLevel()||1;const e=document.createElement("ol");e.className="toc-list",e.setAttribute("role","list");let i=[e];const n=this.createTocList(this.tocTopMap),o=this.createTocList(this.tocBottomMap);this.pendingExternalLinks.forEach((t=>{const e=document.createElement("li");e.className="toc-list--item level-level-0",e.setAttribute("role","listitem");const n=document.createElement("a");n.href=`#${t.id}`,n.textContent=t.text,e.appendChild(n),i[i.length-1].appendChild(e)}));const r=(t,e)=>{null!=t?t.appendChild(e):console.error("Attempted to append to a non-existent element.")};this.tocMap.forEach(((e,n)=>{const{level:o,text:r}=e,s=o-t;if(s>0)for(let t=0;t<s;t++){const t=document.createElement("ol");i[i.length-1].lastElementChild.appendChild(t),i.push(t)}else if(s<0)for(let t=0;t<-s;t++)i.pop();const l=r.replace(/^#/,""),a=document.createElement("li");a.className=`toc-list--item level-${o}`,a.setAttribute("role","listitem");const c=document.createElement("a");c.href=`#${n}`,c.textContent=l,a.appendChild(c),i[i.length-1].appendChild(a),t=o}));const s=document.querySelector(this.navigationContainer);s?(s.innerHTML=`<header><h2>${this.tocIcon}<span>${this.tocTitle}</span></h2></header>`,r(s,n),r(s,e),r(s,o),s.setAttribute("role","doc-toc"),s.addEventListener("click",(t=>{if("A"===t.target.tagName&&t.target.getAttribute("href")){t.preventDefault();const e=t.target.getAttribute("href").substring(1);this.scrollToElement(e)}}))):console.error("Navigation container not found")}attachAnchorsToHeadings(){document.querySelectorAll(`${this.createHeadingSelector()}`).forEach((t=>{if(!this.ignoreSelector||!t.closest(this.ignoreSelector)){const e=this.generateUniqueId(t);t.id=e;const i=t.textContent.trim(),n=document.createElement("a");n.href=`#${e}`,n.setAttribute("aria-label",`Anchor link to ${i}`),n.className="heading-link",n.setAttribute("aria-hidden","true"),n.setAttribute("tabindex","-1");const o=document.createElement("i");o.className="fa-solid fa-link",n.appendChild(o),t.insertBefore(n,t.firstChild)}}))}attachClickListeners(){const t=document.querySelectorAll(".heading-link");t.length>0&&t.forEach((t=>{t.addEventListener("click",this.handleLinkClick.bind(this))}));const e=document.querySelectorAll(`${this.navigationContainer} .toc-list a`);e.length>0&&e.forEach((t=>{t.addEventListener("click",this.handleLinkClick.bind(this))}))}smoothScrollTo(t){const e=window.pageYOffset,i=t-e;let n=null;requestAnimationFrame((function t(o){n||(n=o);const r=o-n,s=Math.min(r/500,1);window.scrollTo(0,e+i*s),r<500&&requestAnimationFrame(t)}))}handleLinkClick(t){t.preventDefault();const e=t.target.closest(".heading-link")?"heading-link":"toc-link",i=t.target.closest("a").getAttribute("href").substring(1),n=document.getElementById(i);if(n){const t=n.getBoundingClientRect().top+window.pageYOffset-this.highlightOffset;console.log(`Link clicked: ${e}`),console.log(`Scroll target position: ${t}px`),this.smoothScrollTo(t)}}createHeadingSelector(){let t=Array.from({length:this.headingDepthLimit},((t,e)=>`${this.contentSelector} h${e+1}`));return this.ignoreSelector&&(t=t.map((t=>`${t}:not(${this.ignoreSelector})`))),t.join(", ")}scrollToElement(t){const e=document.getElementById(t);if(e){this.highlightOffset;const t=e.offsetTop-window.innerHeight/2+e.clientHeight/2;window.scrollTo({top:t,behavior:"smooth"})}}highlightActiveSection(){const t=this.highlightOffset,e=document.querySelectorAll(`${this.contentSelector} h1[id], ${this.contentSelector} h2[id], ${this.contentSelector} h3[id], ${this.contentSelector} h4[id], ${this.contentSelector} h5[id], ${this.contentSelector} h6[id]`),i=Array.from(e).filter((t=>!!document.querySelector(`a[href="#${t.id}"]`))),n=i[i.length-1];let o=!!n&&window.pageYOffset>=n.offsetTop+n.offsetHeight-t;if(i.forEach(((e,n)=>{const r=e.getAttribute("id"),s=document.querySelector(`${this.navigationContainer} .toc-list--item a[href="#${r}"]`),l=i[n+1],a=window.pageYOffset>=e.offsetTop-t;let c=l?window.pageYOffset>=l.offsetTop-t:o;!l&&o&&(c=!1),s&&(a&&!c?s.classList.add("active"):s.classList.remove("active"))})),o&&n){const t=n.getAttribute("id"),e=document.querySelector(`${this.navigationContainer} .toc-list--item a[href="#${t}"]`);e&&!e.classList.contains("active")&&e.classList.add("active")}}addContentToToc(t,e,i){this.tocMap.has(e)||(this.tocMap.set(e,{level:t,text:i}),this.renderTocHtml())}addExternalLinksToToc(t,e="bottom",i="level-0"){if(!Array.isArray(t))throw new Error("Invalid links: Must be an array of link objects.");"top"===e?t.forEach((t=>{if("object"!=typeof t||!t.id||!t.text)throw new Error("Invalid link format: Each link object must have 'id' and 'text' properties.");this.tocTopMap.has(t.id)||this.tocTopMap.set(t.id,{level:i,text:t.text})})):t.forEach((t=>{if("object"!=typeof t||!t.id||!t.text)throw new Error("Invalid link format: Each link object must have 'id' and 'text' properties.");this.tocBottomMap.has(t.id)||this.tocBottomMap.set(t.id,{level:i,text:t.text})})),this.renderTocHtml()}initializeScrollHighlighting(){this.boundHighlightActiveSection=this.highlightActiveSection.bind(this);const t=this.boundHighlightActiveSection;window.addEventListener("scroll",t)}removeEmptyLists(){const t=document.querySelector(this.navigationContainer);if(t){t.querySelectorAll("ol").forEach((t=>{0===t.children.length&&t.parentNode.removeChild(t)}))}}initialize(){this.validateParameters(),this.attachAnchorsToHeadings(),this.populateTocMap(),this.renderTocHtml(),this.initializeScrollHighlighting(),this.removeEmptyLists(),this.attachClickListeners()}}},868:t=>{t.exports=require("@danielhaim/modulator")},253:t=>{t.exports=require("@danielhaim/slugify/src/index.js")}},e={};var i=function i(n){var o=e[n];if(void 0!==o)return o.exports;var r=e[n]={exports:{}};return t[n](r,r.exports,i),r.exports}(987);module.exports=i})();